
library maxlik;
output file = 96mnp.out reset;
dataset = "data962.dat";

    /* Date:	May 9, 2002 */
    /* Author:	Catherine Wilson */
    /* Purpose:	Run MNP to test context model */

let dep = action;
let ind = udem urep contextd contextr hs somecoll ba grad secqrt thrdqrt 
	frthqrt age news12 news36 news7;

proc stval;local b;
   b = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0 };
retp(b); endp;

proc loglik(b,dataset);
   local 
   y,y0,y1,y2,one,a,ubar0,ubar11,ubar22,ubar1,ubar2,ubar12,ubar21,util11,
   util12,util21,util22,util01,util02,beta,sigma0,sigma1,sigma2,
   sigma01,sigma02,sigma12,w111,w121,w122,w211,w221,w222,w011,w021,
   w022,v111,v122,v211,v222,r1,r2,r0,r,uplimout,uplimin,llike,b1,b2,logl;

    /* Set up all of the parameter vectors */
   b1 = b[1:2] | 0 | b[3] | 0 | b[4:14];
   b2 = b[15] | 0 | b[2] | 0 | b[3] | b[16:26];
   sigma12 = b[27];

   /* Creating the dependent variables from action */
   y=dataset[.,1];
   y0=(y .== 0); /* y0 is abstention     */
   y1=(y .== 1); /* y1 is voting for Dem */
   y2=(y .== 2); /* y2 is voting for Rep */

   /* Creating the independent variable matrices */
   one=ones(rows(dataset),1);
   a =one~dataset[.,2:16];

   /* Creating the ubar */
   ubar0 = 0;
   ubar1 = a*b1;
   ubar2 = a*b2;

   ubar12 = ubar1-ubar2; 
   ubar21 = ubar2-ubar1;
   ubar11 = -ubar1;
   ubar22 = -ubar2; 

   /* Create the w's (little omega's) */
   /* The following constraints are hard-wired: */
   /* sigma01 = 0 and sigma02 = 0 */

   sigma01 = 0;
   sigma02 = 0;
   w111 = 1;
   w121 = 1 - sigma12;
   w122 = 1 + 1 - 2*sigma12;
   w211 = 1;
   w221 = 1 - sigma12;
   w222 = 1 + 1 - 2*sigma12;
   w011 = 1;
   w021 = sigma12;
   w022 = 1;
   

   /* Now create the r's (i.e., the correlations between eta's) */
   v111 = sqrt(w111); v122 = sqrt(w122);
   v211 = sqrt(w211); v222 = sqrt(w222);

   r1 = w121 / (v111.*v122);
   r2 = w221 / (v211.*v222);
   r0 = w021;

   r  =  sumc( ((y0~y1~y2).*(r0~r1~r2))');

   /* Creating the utilda's */
   util11 = ubar1./(v111);
   util12 = ubar12./(v122);
   util21 = ubar2./(v211);
   util22 = ubar21./(v222);
   util01 = ubar11./(v111);
   util02 = ubar22./(v222);

   /* Create the limits of integration */
   uplimout  =  sumc( ((y0~y1~y2).*(util01~util11~util21))');
   uplimin   =  sumc( ((y0~y1~y2).*(util02~util12~util22))');

   /* Making the likelihood function */
   
   llike = (cdfbvn(uplimout, uplimin,r));
   llike = ln(llike); retp(llike);

endp;                               

   /* End of Likelihood Function */

   _max_CovPar=0; 
   { b,logl,g,vc,retcode } = maxprt(maxlik(dataset,dep|ind,&loglik,stval));

output off;





   
















 
 

